program DialTest;

uses gtkdial, gtk2, gdk2, glib2;

procedure value_changed (adjustment : PGtkAdjustment; _label : PGtkWidget); cdecl;
var
   buffer : pchar;
begin
   buffer := g_strdup_printf('%4.2f', adjustment^.value);
   gtk_label_set_text(GTK_LABEL(_label), buffer);
end;

var
   window, dial, frame, vbox, _label : PGtkWidget; 
   adjustment : PGtkAdjustment;

begin
   gtk_init(@argc, @argv);

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
  
   gtk_window_set_title(GTK_WINDOW(window), 'Dial');
  
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_exit), nil);
  
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

   vbox := gtk_vbox_new(false, 5);
   gtk_container_add(GTK_CONTAINER(window), vbox);
   gtk_widget_show(vbox);

   frame := gtk_frame_new(nil);
   gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
   gtk_container_add (GTK_CONTAINER(vbox), frame);
   gtk_widget_show(frame); 
 
   adjustment := GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 100, 0.01, 0.1, 0));
  
   dial := gtk_dial_new(adjustment);
   gtk_dial_set_update_policy(GTK_DIAL(dial), GTK_UPDATE_DELAYED);
   { gtk_widget_set_size_request(dial, 100, 100); }
   
   gtk_container_add(GTK_CONTAINER(frame), dial);
   gtk_widget_show(dial);

   _label := gtk_label_new('0.00');
   gtk_box_pack_end(GTK_BOX(vbox), _label, false, false, 0);
   gtk_widget_show(_label);

   g_signal_connect(adjustment, 'value-changed',
                    G_CALLBACK(@value_changed), _label);
  
   gtk_widget_show(window);
  
   gtk_main();
end.

{*EOF*}
